'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.yomoApp = exports.attachReducer = undefined;

var _newYomo = require('./new-yomo.js');

var _reactYomo = require('./react-yomo.js');

var attachReducer = exports.attachReducer = function attachReducer(yomo, reducer) {
  if (yomo.state || yomo.dispatch) {
    console.log('attachReducer: Yomo already attached.');
    return;
  }
  var redux = yomo.yomoState('redux');
  yomo.state = function () {
    return redux.get();
  };
  yomo.dispatch = function (action) {
    return r.write(reducer(r.value, action));
  };
  yomo.dispatchSoon = function (action) {
    return process.nextTick(yomo.dispatch, action);
  };
  yomo.dispatch({ type: '@@redux/INIT' });
};

var ok = { reducer: true, View: true, domId: true };
var yomoApp = exports.yomoApp = function yomoApp(spec) {
  var yomo = (0, _newYomo.newYomo)();
  var reducer = spec.reducer;
  var View = spec.View;
  var domId = spec.domId;

  for (var k in spec) {
    if (!ok[k]) {
      console.log('Warning in yomoApp --- unknown key: ' + k);
    }
  }
  if (reducer) {
    attachReducer(yomo, reducer);
  } else {
    throw new Error('yomoApp requires a reducer');
  }
  View && (0, _reactYomo.yomoRender)(yomo, View, domId);
  return yomo;
};