'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.yomoRun = exports.yomoAuditor = exports.cacheSlow = exports.cacheAsync = exports.onOffAction = exports.onOffActionShared = exports.cacheFnu = exports.cacheFn = exports.cacheCb = exports.metaFn = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _mobx = require('mobx');

var _mobx2 = _interopRequireDefault(_mobx);

var _indexKey = require('./indexKey.js');

var _myExceptions = require('../util/my-exceptions.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var observable = _mobx2.default.observable;
var asReference = _mobx2.default.asReference;
var createTransformer = _mobx2.default.createTransformer;
var autorun = _mobx2.default.autorun;


var nextId = 1;
var metaFn = exports.metaFn = function metaFn(fnTrafo) {
  return function () {
    for (var _len = arguments.length, spec = Array(_len), _key = 0; _key < _len; _key++) {
      spec[_key] = arguments[_key];
    }

    var id = nextId++;
    var fn = function fn(yomo) {
      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      var key = (0, _indexKey.indexKey)(args);
      var cache = yomo.yomoCache[id] = yomo.yomoCache[id] || {};
      var data = cache[key] = cache[key] || {
        cache: cache, key: key, res: fnTrafo(spec, yomo, args)
      };
      return (0, _myExceptions.unwrapEx)(cacheTrafo(data));
    };
    fn.id = id;
    fn.curry = function () {
      for (var _len3 = arguments.length, pref = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        pref[_key3] = arguments[_key3];
      }

      return function (yomo) {
        for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          args[_key4 - 1] = arguments[_key4];
        }

        return fn.apply(undefined, [yomo].concat(pref, args));
      };
    };
    return fn;
  };
};

var cacheTrafo = createTransformer(function (data) {
  return data.res.get();
}, function (res, data) {
  delete data.cache[data.key];
  process.nextTick(function () {
    if (!data.cache[data.key]) {
      if (data.res.unsub) {
        data.res.unsub();
      }
    }
  });
});

var cacheCb = exports.cacheCb = metaFn(function (spec, yomo, args) {
  var _spec = _slicedToArray(spec, 1);

  var fn = _spec[0];
  var v0 = spec.length >= 2 ? spec[1] : _myExceptions.vWait;
  var res = observable(asReference(v0));
  var setRes = _mobx2.default.action(function (e, v) {
    return res.set(e ? (0, _myExceptions.wrapEx)(e) : v);
  });
  res.unsub = fn.apply(undefined, [yomo, setRes].concat(_toConsumableArray(args)));
  return res;
});

var cacheFn = exports.cacheFn = metaFn(function (_ref, yomo, args) {
  var _ref2 = _slicedToArray(_ref, 1);

  var fn = _ref2[0];

  return { get: function get() {
      try {
        return fn.apply(undefined, [yomo].concat(_toConsumableArray(args)));
      } catch (e) {
        return (0, _myExceptions.wrapEx)(e);
      }
    } };
});

var cacheFnu = exports.cacheFnu = metaFn(function (_ref3, yomo, args) {
  var _ref4 = _slicedToArray(_ref3, 1);

  var fn = _ref4[0];

  var res = void 0;
  var unsub = function unsub() {
    try {
      res && res.unsub && res.unsub();
    } catch (e) {
      console.log('cacheFn/unsub:', e);
    }
  };
  var get = function get() {
    unsub();
    try {
      return res = fn.apply(undefined, [yomo].concat(_toConsumableArray(args)));
    } catch (e) {
      return (0, _myExceptions.wrapEx)(e);
    }
  };
  return { get: get, unsub: unsub };
});

var onOff = cacheFnu(function (yomo, id, action) {
  yomo.dispatchSoon(_extends({}, action, { onOff: +1 }));
  return { unsub: function unsub() {
      return yomo.dispatch(_extends({}, action, { onOff: -1 }));
    } };
});
var onOffCounter = 1;
var onOffActionShared = exports.onOffActionShared = function onOffActionShared(yomo) {
  for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
    args[_key5 - 1] = arguments[_key5];
  }

  onOff.apply(undefined, [yomo, 0].concat(args));return true;
};
var onOffAction = exports.onOffAction = function onOffAction(yomo) {
  for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
    args[_key6 - 1] = arguments[_key6];
  }

  onOff.apply(undefined, [yomo, onOffCounter++].concat(args));return true;
};

var cacheAsync = exports.cacheAsync = metaFn(function (_ref5, yomo, args) {
  var _ref6 = _slicedToArray(_ref5, 1);

  var fn = _ref6[0];

  var res = observable(asReference(_myExceptions.vWait));
  try {
    fn.apply(undefined, [yomo].concat(_toConsumableArray(args))).then(_mobx2.default.action(function (v) {
      res.set(v);
    }));
    return res;
  } catch (e) {
    return (0, _myExceptions.wrapEx)(e);
  }
});
var cacheSlow = exports.cacheSlow = metaFn(function (_ref7, yomo, args) {
  var _ref8 = _slicedToArray(_ref7, 1);

  var spec = _ref8[0];
  var fn = spec.fn;
  var delay = spec.delay;
  var refresh = spec.refresh;

  var res = observable(asReference(_myExceptions.vDelay));
  var id = void 0;
  var tick = function tick(dt, wait) {
    id = setTimeout(function () {
      try {
        if (wait) {
          _mobx2.default.action(function () {
            return res.set(_myExceptions.vWait);
          })();
        }
        fn.apply(undefined, [yomo].concat(_toConsumableArray(args))).then(_mobx2.default.action(function (v) {
          res.set(v);next();
        }));
      } catch (e) {
        _mobx2.default.action(function (v) {
          res.set((0, _myExceptions.wrapEx)(e));
        })();
        next();
      }
    }, dt);
  };
  var next = function next() {
    if (refresh) {
      tick(refresh);
    }
  };
  tick(delay || 1, true);
  res.unsub = function () {
    return clearTimeout(id);
  };
  return res;
});

var yomoAuditor = exports.yomoAuditor = metaFn(function (_ref9, yomo, args) {
  var _ref10 = _slicedToArray(_ref9, 1);

  var fn = _ref10[0];

  var res = observable(true);
  res.unsub = yomoRun(yomo, false, function () {
    var action = fn.apply(undefined, [yomo].concat(_toConsumableArray(args)));
    if (action) {
      yomo.dispatch(action);
    }
  });
  return res;
});

var yomoRun0 = function yomoRun0(yomo, fn) {
  return autorun(function () {
    try {
      fn(yomo);
    } catch (e) {
      if (!(0, _myExceptions.isWaitX)(e)) {
        console.log('yomoRun:', e);
        console.log(e.stack);
      }
    }
  });
};

var yomoRun = exports.yomoRun = function yomoRun(yomo, key, fn) {
  if (!key) {
    return yomoRun0(yomo, fn);
  }

  var _ref11 = yomo.yomoRuns[key] || [];

  var _ref12 = _slicedToArray(_ref11, 2);

  var oldFn = _ref12[0];
  var oldStop = _ref12[1];

  if (oldFn === fn) {
    return;
  }
  if (oldFn) {
    oldStop();
    fn && console.log('double yomoRun for', key);
  }
  if (fn) {
    yomo.yomoRuns[key] = [fn, yomoRun0(yomo, fn)];
  } else {
    delete yomo.yomoRuns[key];
  }
  return function () {
    var _ref13 = yomo.yomoRuns[key] || [];

    var _ref14 = _slicedToArray(_ref13, 2);

    var oldFn = _ref14[0];
    var oldStop = _ref14[1];

    if (fn !== oldFn) {
      console.log('yomoRun stop too late', key);
    } else if (oldStop) {
      oldStop();delete yomo.yomoRuns[key];
    }
  };
};