'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pipes = exports.getPipe = exports.linkPipes = exports.remoteFn = exports.newBridge = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _mobx = require('mobx');

var _mqtt = require('mqtt');

var _mqtt2 = _interopRequireDefault(_mqtt);

var _cacheFn = require('./cacheFn.js');

var _reuse = require('../util/reuse');

var _mqttBridge = require('./mqtt-bridge.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var newBridge = exports.newBridge = (0, _cacheFn.metaFn)(function (_ref, yomo, _ref2) {
  var _ref4 = _slicedToArray(_ref, 1);

  var spec0 = _ref4[0];

  var _ref3 = _slicedToArray(_ref2, 1);

  var spec1 = _ref3[0];

  var bridge = (0, _mqttBridge.mqttBridge)(yomo, _extends({}, spec0, spec1 || {}), iFuncs, compressor);
  return { get: function get() {
      return bridge;
    }, unsub: function unsub() {
      return bridge.end();
    } };
});

var remoteFn = exports.remoteFn = (0, _cacheFn.metaFn)(function (_ref5, yomo, args0) {
  var _ref6 = _slicedToArray(_ref5, 3);

  var bridgeFn = _ref6[0];
  var info = _ref6[1];
  var mkx = _ref6[2];

  if (!info) {
    var _args = args0;

    var _args2 = _toArray(_args);

    info = _args2[0];
    args0 = _args2.slice(1);
  } // take info from args0
  var _info = info;

  var _info2 = _slicedToArray(_info, 3);

  var peerId = _info2[0];
  var fname = _info2[1];
  var bSpec = _info2[2];

  var res = (0, _mobx.observable)((0, _mobx.asReference)(0)); // ==> exception!!

  var _ref7 = mkx ? mkx(yomo, res, args0, info) : [function (data) {
    return res.set(data);
  }, args0];

  var _ref8 = _slicedToArray(_ref7, 2);

  var x = _ref8[0];
  var args = _ref8[1];

  var unsub1 = (0, _mobx.autorun)(function () {
    (res.unsub || function () {})();
    var bridge = bridgeFn.apply(undefined, [yomo].concat(_toConsumableArray(bSpec || [])));
    var unsub2 = bridge.proxyFn(peerId, fname, args, (0, _mobx.action)(x));
    res.unsub = function () {
      unsub2();unsub1();
    };
  });
  return res;
});

// (bridgeFn,[peerId,fname,bSpec,localPipeId,remotePipeId])
var linkPipes = exports.linkPipes = function linkPipes(bridgeFn, info) {
  return remoteFn(bridgeFn, info, function (yomo, _1, _2, _ref9) {
    var _ref10 = _slicedToArray(_ref9, 5);

    var _a = _ref10[0];
    var _b = _ref10[1];
    var _c = _ref10[2];
    var id = _ref10[3];
    var id2 = _ref10[4];
    return [function (data) {
      var type = 'pipe';
      var action = data.data ? _extends({}, data, { type: type, id: id }) : { type: type, id: id, acc: 1, key: data };
      yomo.dispatch(action);
    }, [id2, topOf(yomo().pipes[id] || emptyPipe)]];
  });
};
var emptyPipe = { bottom: 0, data: [] };
var getPipe = exports.getPipe = (0, _cacheFn.cacheFn)(function (yomo, id) {
  return yomo().pipes[id] || emptyPipe;
});
var pipes = exports.pipes = function pipes() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var action = arguments[1];

  if (action.type !== 'pipe') {
    return state;
  }
  var id = action.id;
  if (!id) {
    return state;
  }
  return (0, _reuse.reuse)(state, _extends({}, state, _defineProperty({}, id, pipe(state[id], action))));
};
var pipe = function pipe() {
  var state = arguments.length <= 0 || arguments[0] === undefined ? emptyPipe : arguments[0];
  var action = arguments[1];
  var acc = action.acc;
  var key = action.key;
  var value = action.value;
  var b2 = action.bottom;
  var d2 = action.data;
  var bottom = state.bottom;
  var data = state.data;
  var top = bottom + data.length;
  if (d2) {
    if (b2 > top) {
      console.log('skipped data2 (ok)', state, action);
      bottom = b2;data = d2;
    } else {
      var tmp = d2.slice(top - b2);
      if (tmp.length > 0) {
        data = [].concat(_toConsumableArray(data), _toConsumableArray(tmp));
      }
    }
  } else if (acc) {
    if (key > bottom) {
      data = data.slice(key - bottom);
      bottom = key;
    }
  } else {
    if (key === undefined || key === top) {
      data = [].concat(_toConsumableArray(data), [value]);
    } else if (key > top + 1) {
      console.log('skipped keys', top, key);
    }
  }
  return (0, _reuse.reuse)(state, { bottom: bottom, data: data });
};

var topOf = function topOf(_ref11) {
  var bottom = _ref11.bottom;
  var data = _ref11.data;
  return bottom + data.length;
};
var accTop = (0, _cacheFn.cacheFn)(function (c, id) {
  return topOf(getPipe(c, id));
});
var accBot = (0, _cacheFn.cacheFn)(function (c, id) {
  return getPipe(c, id).bottom;
});
var iFuncs = { accTop: accTop, accBot: accBot, pipeData: getPipe };
var compressor = {
  pipeData: function pipeData(_ref12) {
    var _ref13 = _slicedToArray(_ref12, 2);

    var id = _ref13[0];
    var lastBottom = _ref13[1];
    return function (_ref14) {
      var bottom = _ref14.bottom;
      var data = _ref14.data;

      if (bottom > lastBottom) {
        console.log('skiped data (ok)');
      }
      if (bottom < lastBottom) {
        data = data.slice(lastBottom - bottom);
        bottom = lastBottom;
      }
      lastBottom = bottom + data.length;
      return { bottom: bottom, data: data };
    };
  }
};