'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.newYomo = undefined;

var _mobx = require('mobx');

var _mobx2 = _interopRequireDefault(_mobx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var useStrict = _mobx2.default.useStrict;
var observable = _mobx2.default.observable;
var asReference = _mobx2.default.asReference;

useStrict(true);

var newYomo = exports.newYomo = function newYomo() {
  var states = {};
  var yomoState = function yomoState(k) {
    var res = states[k];
    if (!res) {
      res = states[k] = rxValue(undefined);
    }
    return res;
  };
  return { yomoState: yomoState, yomoCache: {}, yomoRuns: {} };
};

var rxValue = function rxValue(data) {
  var r = observable(asReference(data));
  r.data = data;
  r.write = _mobx2.default.action(function (vv) {
    return r.set(r.data = vv);
  });
  return r;
};