'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.waitUntil = exports.dispatchAfter = exports.yomoClock = exports.timeNow = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _mobx = require('mobx');

var _cacheFn = require('./cacheFn.js');

var _myExceptions = require('../util/my-exceptions.js');

var timeNow = exports.timeNow = function timeNow() {
  return +new Date();
};
var clock0 = function clock0(tn, t0, dt) {
  return dt ? Math.ceil((tn - t0) / dt) : tn > t0 ? 1 : 0;
};

var yomoClock = exports.yomoClock = (0, _cacheFn.metaFn)(function (__, yomo, _ref) {
  var _ref2 = _slicedToArray(_ref, 3);

  var t0 = _ref2[0];
  var dt = _ref2[1];
  var skip = _ref2[2];

  var tn = timeNow();var r = clock0(tn, t0, dt);
  var set = (0, _mobx.action)(function (v) {
    return res.set(r = v);
  });
  var res = (0, _mobx.observable)((0, _mobx.asReference)(r));
  var id = void 0;res.unsub = function () {
    return id && clearTimeout(id);
  };

  if (dt) {
    (function () {
      var nextStep = function nextStep(firstRun) {
        if (!firstRun) {
          tn = timeNow();
          r = skip ? Math.max(r + 1, clock0(tn, t0, dt)) : r + 1;
          set(r);
        }
        id = setTimeout(nextStep, Math.max(t0 + r * dt - tn, dt / 3));
      };
      nextStep(true);
    })();
  } else if (r === 0) {
    id = setTimeout(function () {
      return set(1);
    }, t0 - tn);
  }
  return res;
})();

var dispatchAfter = exports.dispatchAfter = (0, _cacheFn.cacheFn)(function (yomo, t0, action, addTime) {
  if (yomoClock(yomo, t0) > 0) {
    if (addTime) {
      action = _extends({}, action, { time: timeNow() });
    }
    process.nextTick(function () {
      return yomo.dispatch(action);
    });
  }
  return true;
});

var waitUntil = exports.waitUntil = (0, _cacheFn.cacheFn)(function (yomo, t0, delay) {
  if (yomoClock(yomo, t0) == 0) {
    throw delay ? _myExceptions.delayException : _myExceptions.waitException;
  }
  return true;
});