'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getJSON = exports.getText = exports.getBuffer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slurp = require('./slurp.js');

var Promise = require('bluebird');
var http = require('http');
var https = require('https');
var url = require('url');


var bytes = function bytes(d) {
  return Buffer.byteLength(d);
};
var getBuffer = exports.getBuffer = Promise.promisify(function (opts, cb) {
  if (typeof opts === 'string') {
    opts = { url: opts };
  }
  if (opts.url) {
    opts = _extends({}, opts, url.parse(opts.url));
  }
  if (opts.body !== undefined) {
    opts = _extends({}, opts, { 'Content-Length': bytes(opts.body) });
  }
  var h = opts.protocol === 'https:' ? https : http;
  var req = h.request(opts, function (res) {
    return (0, _slurp.slurp)(res, cb);
  });
  if (opts.body !== undefined) {
    req.write(opts.body);
  }
  req.end();
});

var mget = function mget(trafo) {
  return function (url) {
    return getBuffer(url).then(trafo);
  };
};
var getText = exports.getText = mget(function (data) {
  return data.toString();
});
var getJSON = exports.getJSON = mget(function (data) {
  return JSON.parse(data.toString());
});