'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.yomoIcons = exports.ViewException = exports.ProgramErrorIcon = exports.UserErrorIcon = exports.OkIcon = exports.DelayIcon = exports.WaitIcon = exports.iconCss = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactYomo = require('../core/react-yomo.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var iconCss = exports.iconCss = '.yomoSpin1s {\n  -moz-animation: yomoSpin1s 1s infinite linear;\n  -webkit-animation: yomoSpin1s 1s infinite linear;\n  -ms-animation: yomoSpin1s 1s infinite linear;\n  animation: yomoSpin1s 1s  infinite linear;\n}\n\n@-moz-keyframes yomoSpin1s {\n  0% { -moz-transform: rotate(0deg); }\n  100% { -moz-transform: rotate(360deg); }\n}\n@-webkit-keyframes yomoSpin1s {\n  0% { -webkit-transform: rotate(0deg); }\n  100% { -webkit-transform: rotate(360deg); }\n}\n@keyframes yomoSpin1s {\n  0% {transform:rotate(0deg);}\n  100% {transform:rotate(360deg);}\n}';

var viewBox = '0 0 24 24';
var s0 = '1em';
var strokes = {
  strokeWidth: 2, strokeLinecap: 'round', strokeLinejoin: 'round'
};
var ySpin = 'yomoSpin1s';

var WaitIcon = exports.WaitIcon = (0, _reactYomo.yomoView)(function (_ref) {
  var style = _ref.style;
  var size = _ref.size;
  return _react2.default.createElement(
    'svg',
    { style: style, className: ySpin, width: size || s0, viewBox: viewBox },
    _react2.default.createElement(
      'g',
      null,
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#888888', fill: 'none',
        d: 'M 12 2 a 10 10 0 1 0 10 10'
      }))
    )
  );
});
var DelayIcon = exports.DelayIcon = (0, _reactYomo.yomoView)(function (_ref2) {
  var style = _ref2.style;
  var size = _ref2.size;
  return _react2.default.createElement(
    'svg',
    { style: style, width: size || s0, viewBox: viewBox },
    _react2.default.createElement(
      'g',
      null,
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#888888', fill: 'none',
        d: 'M 12 2 a 10 10 0 1 0 10 10'
      }))
    )
  );
});
var OkIcon = exports.OkIcon = (0, _reactYomo.yomoView)(function (_ref3) {
  var style = _ref3.style;
  var size = _ref3.size;
  return _react2.default.createElement(
    'svg',
    { style: style, width: size || s0, viewBox: viewBox },
    _react2.default.createElement(
      'g',
      null,
      _react2.default.createElement('circle', { cx: 12, cy: 12, r: 12, fill: 'green' }),
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#FFFFFF', fill: 'none',
        d: 'M6,13 l4,4 l8.5,-8.5'
      }))
    )
  );
});
var UserErrorIcon = exports.UserErrorIcon = (0, _reactYomo.yomoView)(function (_ref4) {
  var style = _ref4.style;
  var size = _ref4.size;
  return _react2.default.createElement(
    'svg',
    { style: style, width: size || s0, viewBox: viewBox },
    _react2.default.createElement(
      'g',
      null,
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#D80000', fill: '#D80000',
        d: 'M1,23 l22,0 l-11,-22 z'
      })),
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#FFFFFF',
        d: 'M12,8 l0,7'
      })),
      _react2.default.createElement('path', _extends({}, _extends({}, strokes, { strokeWidth: 3 }), { stroke: '#FFFFFF',
        d: 'M12,19.5 l0,0'
      }))
    )
  );
});
var ProgramErrorIcon = exports.ProgramErrorIcon = (0, _reactYomo.yomoView)(function (_ref5) {
  var style = _ref5.style;
  var size = _ref5.size;
  return _react2.default.createElement(
    'svg',
    { style: style, width: size || s0, viewBox: viewBox },
    _react2.default.createElement(
      'g',
      null,
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#AA0000', fill: '#AA0000',
        d: 'M1,23 l22,0 l-11,-22 z'
      })),
      _react2.default.createElement('path', _extends({}, strokes, { stroke: '#FFFF00',
        d: 'M12,8 l0,7'
      })),
      _react2.default.createElement('path', _extends({}, _extends({}, strokes, { strokeWidth: 3 }), { stroke: '#FFFF00',
        d: 'M12,19.5 l0,0'
      }))
    )
  );
});

var ViewException = exports.ViewException = (0, _reactYomo.yomoView)(function (_ref6) {
  var waiting = _ref6.waiting;
  var exception = _ref6.exception;

  var p = { size: '2em' };
  if (waiting) {
    return waiting > 0 ? _react2.default.createElement(WaitIcon, p) : _react2.default.createElement(DelayIcon, p);
  } else {
    console.log(exception);
    return _react2.default.createElement(UserErrorIcon, p);
  }
});

var yomoIcons = exports.yomoIcons = { css: iconCss, ViewException: ViewException };