"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var wrapExFn = exports.wrapExFn = function wrapExFn(fn, v0) {
  return function () {
    try {
      return fn.apply(undefined, arguments);
    } catch (exception) {
      return v0 !== undefined ? v0 : wrapEx(exception);
    }
  };
};
var wrapEx = exports.wrapEx = function wrapEx(exception) {
  return { exception: exception };
};
var unwrapEx = exports.unwrapEx = function unwrapEx(v) {
  var e = v && v.exception;
  if (e) {
    throw e;
  } else {
    return v;
  }
};

function WaitException() {
  this.waiting = true;
  this.name = "waitException";
  this.message = "Waiting for some event or for input...";
}
function DelayException() {
  this.waiting = this.delaying = true;
  this.name = "delayException";
  this.message = "Intentionally delaying progress...";
}

var waitException = exports.waitException = new WaitException();
var delayException = exports.delayException = new DelayException();

var vWait = exports.vWait = wrapEx(waitException);
var vDelay = exports.vDelay = wrapEx(delayException);

// wait=>+1 delay=>-1 else=>0
var isWaitX = exports.isWaitX = function isWaitX(e) {
  return e.waiting ? e.delaying ? -1 : +1 : 0;
};