'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.xRdDir = exports.xRdBuffer = exports.xRdTxt = exports.xRdJson = exports.pathType = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _fs = require('fs');

var _path = require('path');

var _cacheFn = require('../core/cacheFn.js');

var watch0 = function watch0(path, cb) {
  try {
    var _ret = function () {
      var watcher = (0, _fs.watch)(path, cb);
      return {
        v: function v() {
          return watcher.close();
        }
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  } catch (e) {
    return function () {};
  }
};

var watch1 = function watch1(path, cb) {
  var base = (0, _path.basename)(path);var dir = (0, _path.dirname)(path);
  var clearFileWatch = void 0,
      clearDirWatch = void 0;
  var check = function check(on, invalid) {
    if (invalid) {
      clearFileWatch && clearFileWatch();clearFileWatch = null;
    }
    if (on) {
      clearFileWatch = clearFileWatch || watch0(path, cb1);
    } else {
      clearDirWatch = clearDirWatch || watch1(dir, cb2);
    }
    (0, _fs.access)(path, function (e) {
      if (e) {
        // path does not exist.
        if (!clearDirWatch) {
          check(false);
        } else {
          clearFileWatch && clearFileWatch();clearFileWatch = null;
          cb('off');
        }
      } else {
        // path does exist.
        if (!clearFileWatch) {
          check(true);
        } else {
          clearDirWatch && clearDirWatch();clearDirWatch = null;
          cb('on');
        }
      }
    });
  };
  var cb1 = function cb1(event, file) {
    if (event === 'rename' && file === base) {
      check(false, true);
    } else {
      cb(event, file);
    }
  };
  var cb2 = function cb2(event, file) {
    if (event === 'off') {
      return;
    }
    if (file === base || file === undefined) {
      check(true);
    }
  };

  check(true);
  return function () {
    clearFileWatch && clearFileWatch();
    clearDirWatch && clearDirWatch();
  };
};

var diff0 = function diff0(a, b) {
  return a !== b;
};
var watch2 = function watch2(path, trafo, norm, cmp, cb) {
  var old = void 0;
  path = (0, _path.resolve)(path);
  return watch1(path, function () {
    trafo(path, function (error, res) {
      if (!error && res && norm) {
        res = norm(res);
      }
      if (!old || !res || cmp(old, res)) {
        cb(error, old = res);
      }
    });
  });
};

var pathType = exports.pathType = (0, _cacheFn.cacheCb)(function (yomo, cb, path) {
  return watch2(path, pathType0, null, diff0, cb);
});
var pathType0 = function pathType0(path, cb) {
  return (0, _fs.stat)(path, function (err, res) {
    return cb(null, err ? 'error' : res.isFile() ? 'file' : res.isDirectory() ? 'directory' : 'other');
  });
};

var xRdJson = exports.xRdJson = function xRdJson(yomo, path) {
  return JSON.parse(xRdTxt(yomo, path));
};
var xRdTxt = exports.xRdTxt = function xRdTxt(yomo, path) {
  return xRdBuffer(yomo, path).toString();
};

var xRdBuffer = exports.xRdBuffer = (0, _cacheFn.cacheCb)(function (yomo, cb, path) {
  return watch2(path, _fs.readFile, null, Buffer.compare, cb);
});
var xRdDir = exports.xRdDir = (0, _cacheFn.cacheCb)(function (yomo, cb, path) {
  return watch2(path, _fs.readdir, function (a) {
    return a.sort();
  }, arraysDiffer, cb);
});

var arraysDiffer = function arraysDiffer(a, b) {
  if (a.length != b.length) {
    return true;
  }
  for (var i = 0; i < a.length; i++) {
    if (a[i] !== b[i]) {
      return true;
    }
  }
  return false;
};